import { AutoMap } from '@automapper/classes';
import { PointType } from '../../../geography/domain/types/point-type.enum';
import { Coordinates } from '../../../geography/domain/entities/coordinates';

export class Ad {
  @AutoMap()
  uuid: string;

  @AutoMap()
  driver: boolean;

  @AutoMap()
  passenger: boolean;

  @AutoMap()
  frequency: number;

  @AutoMap()
  fromDate: Date;

  @AutoMap()
  toDate: Date;

  @AutoMap()
  monTime: Date;

  @AutoMap()
  tueTime: Date;

  @AutoMap()
  wedTime: Date;

  @AutoMap()
  thuTime: Date;

  @AutoMap()
  friTime: Date;

  @AutoMap()
  satTime: Date;

  @AutoMap()
  sunTime: Date;

  @AutoMap()
  monMargin: number;

  @AutoMap()
  tueMargin: number;

  @AutoMap()
  wedMargin: number;

  @AutoMap()
  thuMargin: number;

  @AutoMap()
  friMargin: number;

  @AutoMap()
  satMargin: number;

  @AutoMap()
  sunMargin: number;

  @AutoMap()
  driverDuration: number;

  @AutoMap()
  driverDistance: number;

  @AutoMap()
  passengerDuration: number;

  @AutoMap()
  passengerDistance: number;

  @AutoMap()
  originType: PointType;

  @AutoMap()
  destinationType: PointType;

  @AutoMap(() => [Coordinates])
  waypoints: Coordinates[];

  @AutoMap()
  direction: string;

  @AutoMap()
  fwdAzimuth: number;

  @AutoMap()
  backAzimuth: number;

  @AutoMap()
  seatsDriver: number;

  @AutoMap()
  seatsPassenger: number;

  @AutoMap()
  seatsUsed: number;

  @AutoMap()
  createdAt: Date;

  @AutoMap()
  updatedAt: Date;
}
