import { CommandHandler } from '@nestjs/cqrs';
import { RedisConfigurationRepository } from '../../adapters/secondaries/redis-configuration.repository';
import { SetConfigurationCommand } from '../../commands/set-configuration.command';

@CommandHandler(SetConfigurationCommand)
export class SetConfigurationUseCase {
  constructor(private _configurationRepository: RedisConfigurationRepository) {}

  async execute(setConfigurationCommand: SetConfigurationCommand) {
    await this._configurationRepository.set(
      setConfigurationCommand.setConfigurationRequest.domain +
        ':' +
        setConfigurationCommand.setConfigurationRequest.key,
      setConfigurationCommand.setConfigurationRequest.value,
    );
  }
}
