import { Injectable } from '@nestjs/common';
import { Geodesic } from '../../../geography/adapters/secondaries/geodesic';
import { IGeodesic } from '../../../geography/domain/interfaces/geodesic.interface';

@Injectable()
export class MatcherGeodesic implements IGeodesic {
  constructor(private readonly geodesic: Geodesic) {}

  inverse = (
    lon1: number,
    lat1: number,
    lon2: number,
    lat2: number,
  ): { azimuth: number; distance: number } =>
    this.geodesic.inverse(lon1, lat1, lon2, lat2);
}
