import { IRequestAd } from '../../interfaces/ad-request.interface';

export class Ad {
  private adRequest: IRequestAd;
  private defaultUuid: string;
  private defaultMarginDuration: number;
  uuid: string;
  marginDurations: number[];

  constructor(
    adRequest: IRequestAd,
    defaultUuid: string,
    defaultMarginDuration: number,
  ) {
    this.adRequest = adRequest;
    this.defaultUuid = defaultUuid;
    this.defaultMarginDuration = defaultMarginDuration;
  }

  init = (): void => {
    this.setUuid(this.adRequest.uuid ?? this.defaultUuid);
    this.setMarginDurations([
      this.defaultMarginDuration,
      this.defaultMarginDuration,
      this.defaultMarginDuration,
      this.defaultMarginDuration,
      this.defaultMarginDuration,
      this.defaultMarginDuration,
      this.defaultMarginDuration,
    ]);
  };

  setUuid = (uuid: string): void => {
    this.uuid = uuid;
  };

  setMarginDurations = (marginDurations: number[]): void => {
    this.marginDurations = marginDurations;
  };
}
