import { Ad } from '../../../../domain/entities/ecosystem/ad';

const DEFAULT_UUID = '00000000-0000-0000-0000-000000000000';
const MARGIN_DURATION = 900;

describe('Ad entity', () => {
  it('should be defined', () => {
    const ad = new Ad(
      {
        uuid: '774aaab2-77df-4c6c-b70d-7b9e972e5bbc',
      },
      DEFAULT_UUID,
      MARGIN_DURATION,
    );
    expect(ad).toBeDefined();
  });

  describe('init', () => {
    it('should initialize an ad with a uuid', () => {
      const ad = new Ad(
        {
          uuid: '774aaab2-77df-4c6c-b70d-7b9e972e5bbc',
        },
        DEFAULT_UUID,
        MARGIN_DURATION,
      );
      ad.init();
      expect(ad.uuid).toBe('774aaab2-77df-4c6c-b70d-7b9e972e5bbc');
      expect(ad.marginDurations[0]).toBe(900);
      expect(ad.marginDurations[6]).toBe(900);
    });
    it('should initialize an ad without a uuid', () => {
      const ad = new Ad({}, DEFAULT_UUID, MARGIN_DURATION);
      ad.init();
      expect(ad.uuid).toBe('00000000-0000-0000-0000-000000000000');
      expect(ad.marginDurations[0]).toBe(900);
      expect(ad.marginDurations[6]).toBe(900);
    });
  });
});
